import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import * as THREE from "three";
import { useMemo } from "react";
import { Entity, Scene } from "aframe-react";
import { generateLabel } from "./generate-label";
import { getColorFromId } from "./get-color-from-id";
import { getGraphData } from "./get-graph-data";
import { useNodeDragger } from "./hooks/use-node-dragger";
import { useSpaceId } from "../hooks";
export const AframeGraph = ({ deep, links }) => {
    const [spaceId, setSpaceId] = useSpaceId();
    const handleNodeHover = (node) => {
        if (node) {
        }
    };
    const { initialize } = useNodeDragger();
    const graphData = useMemo(() => {
        return getGraphData(deep, links, spaceId);
    }, [links]);
    return (_jsx(_Fragment, { children: _jsxs(Scene, { scaler: true, rotator: true, dragger: true, id: "scene", "vr-mode-ui": "enterVRButton: #vr; enterARButton: #ar", renderer: "logarithmicDepthBuffer: true", children: [_jsx(Entity, { camera: { active: true, fov: 94 }, "look-controls": { enabled: true }, "wasd-controls": { enabled: true, fly: true }, "orbit-controls": { enabled: true }, position: { x: -1, y: 4, z: 10 } }), _jsx(Entity, { id: "left", "el-movement": true, raycaster: "show-line:true; lineColor: steelblue; lineOpacity: 0.85; objects: #sphere, [forcegraph]", "laser-controls": { hand: "left" }, "hand-tracking-controls": { hand: "left" } }), _jsx(Entity, { id: "right", "el-movement": true, raycaster: "show-line:true; lineColor: steelblue; lineOpacity: 0.85; objects: #sphere, [forcegraph]", "laser-controls": { hand: "right" }, "hand-tracking-controls": { hand: "right" }, "hand-tracking-extras": true, children: _jsx(Entity, { "finger-cursor": true, raycaster: "objects: [forcegraph]; lineColor: steelblue; lineOpacity: 0.85;" }) }), _jsx(Entity, { id: "fg", scale: { x: 0.02, y: 0.02, z: 0.02 }, position: { x: 0, y: 0.5, z: 0 }, forcegraph: {
                        nodes: graphData.nodes,
                        links: graphData.edges,
                        linkWidth: 0.4,
                        linkDirectionalArrowLength: 4,
                        linkDirectionalArrowRelPos: 1,
                        nodeResolution: 16,
                        nodeColor: (node) => getColorFromId(node.type_id),
                        nodeOpacity: 1,
                        nodeThreeObjectExtend: true,
                        nodeThreeObject: (node) => {
                            const group = new THREE.Group();
                            let nodeid = generateLabel(node.id, getColorFromId(node.type_id));
                            nodeid.position.set(0, 10, 0);
                            group.add(nodeid);
                            if (node.type) {
                                let nodetype = generateLabel(node.type, getColorFromId(node.type_id));
                                nodetype.position.set(0, 6, 0);
                                group.add(nodetype);
                            }
                            if (node.name) {
                                let nodename = generateLabel(node.name, getColorFromId(node.type_id));
                                nodename.position.set(0, -6, 0);
                                group.add(nodename);
                            }
                            const radius = 3;
                            const sphereGeometry = new THREE.SphereGeometry(radius, 16, 16);
                            const sphereMaterial = new THREE.MeshStandardMaterial({
                                color: getColorFromId(node.type_id),
                                emissive: getColorFromId(node.type_id),
                                emissiveIntensity: 2
                            });
                            let sphere = new THREE.Mesh(sphereGeometry, sphereMaterial);
                            group.add(sphere);
                            return group;
                        },
                        onNodeHover: handleNodeHover,
                    } }), _jsx(Entity, { id: "sphere", geometry: { primitive: "sphere", radius: 0.5 }, position: { x: 5, y: 2, z: 0 }, material: {
                        shader: "standard",
                        color: "#a200ff",
                        emissive: "#a200ff",
                        emissiveIntensity: 1
                    } })] }) }));
};
//# sourceMappingURL=aframe-graph.js.map