import { Link } from "@deep-foundation/deeplinks/imports/minilinks";
import React from "react";
export interface IInsertedLink {
    position: {
        x: number;
        y: number;
    };
    from: number;
    to: number;
    alterResolve?: (link: Link<number>) => void;
    props?: any;
}
export interface IUpdatedLink {
    position: {
        x: number;
        y: number;
    };
    from: number;
    to: number;
}
export interface IInsertedLinkProps {
    insertingLink?: IInsertedLink;
    setInsertingLink?: (insertingLink: IInsertedLink) => void;
    ml?: any;
    ehRef?: any;
    returningRef?: any;
    insertLinkRef?: any;
}
export declare const FinderPopover: React.NamedExoticComponent<{
    link: Link<number>;
    onSubmit: (link: any) => void;
    onChange?: (link: any) => void;
    onOpen?: () => void;
    onClose?: () => void;
    children?: any;
    PopoverProps?: any;
    PortalProps?: any;
    ClientHandlerProps?: any;
    query?: any;
    search?: string;
}>;
export declare function CytoReactLinksCardInsertNode({ insertingLink, setInsertingLink, ml, ehRef, returningRef, insertLinkRef, }: IInsertedLinkProps): import("react/jsx-runtime").JSX.Element;
export declare function useLinkInserting(elements: any[], reactElements: any[], focus: any, cyRef: any, ehRef: any): {
    openSearchCard: (searchLink: IInsertedLink) => void;
    insertLink: (type_id: any, from: any, to: any, position: any) => Promise<void>;
    openInsertCard: (insertedLink: IInsertedLink) => void;
    insertingCytoRef: React.MutableRefObject<import("../hooks").IInsertingCytoStore>;
    insertingCyto: import("../hooks").IInsertingCytoStore;
    startUpdatingLink: (id: number) => void;
    startInsertingOfType: (id: number, From: number, To: number) => void;
    drawendInserting: (position: any, from: any, to: any) => void;
    drawendUpdating: (position: any, from: any, to: any) => void;
};
export declare function useLinkReactElements(elements: any[], reactElements: any[], cy: any, ml: any, spaceId: any): {
    toggleLinkReactElement: (id: number) => Promise<void>;
    linkReactElements: number[];
};
export declare function useCytoEditor(): [boolean, (value: boolean | import("@deep-foundation/store/store").IUseStoreSetHandler<boolean>) => any, () => any, boolean];
export declare function useCyInitializer({ elementsRef, elements, reactElements, cyRef, setCy, ehRef, cytoViewportRef, rootRef, useSpaceId: _useSpaceId, }: {
    elementsRef: any;
    elements: any;
    reactElements: any;
    cyRef: any;
    setCy: any;
    ehRef: any;
    cytoViewportRef: any;
    rootRef?: any;
    useSpaceId?: any;
}): {
    onLoaded: (ncy: any) => () => void;
};
export declare function useCytoHandlersRules(): [{}, (value: {} | import("@deep-foundation/store/store").IUseStoreSetHandler<{}>) => any, () => any, boolean];
